
function [x1,x2]=SBX_crossover(x1,x2, prob,def)

if(rand(1)<=def.crossover_prob)
for i = 1:length(x1)
    if rand(1) <= 0.5
        [y1, y2] = op_SBX(x1(i), x2(i), prob.range(i,1), prob.range(i,2), def.crossover_sbx_eta);
        x1(i) = y1;
        x2(i) = y2;
    end
end
end

return

function [y1, y2] = op_SBX(x1, x2, x_min, x_max, eta)
% Make sure the variables are not the same
if abs(x1-x2) > 1.e-14
    % make sure x1 < x2
    if x2 < x1, tmp = x1; x1 = x2; x2 = tmp; end
    
    r = rand(1);
    beta = 1 + (2 * (x1-x_min) / (x2-x1));
    alpha = 2 - beta^-(eta+1);
    if r <= 1/alpha
        betaq = (r*alpha)^(1/(eta+1));
    else
        betaq = (1/(2-r*alpha))^(1/(eta+1));
    end
    y1 = 0.5 * (x1+x2 - betaq*(x2-x1));
    
    beta = 1 + (2 * (x_max-x2) / (x2-x1));
    alpha = 2 - beta^-(eta+1);
    if r <= 1/alpha
        betaq = (r*alpha)^(1/(eta+1));
    else
        betaq = (1/(2-r*alpha))^(1/(eta+1));
    end
    y2 = 0.5 * (x1+x2 + betaq*(x2-x1));
    
    if y1 < x_min, y1 = x_min; end
    if y1 > x_max, y1 = x_max; end
    
    if y2 < x_min, y2 = x_min; end
    if y2 > x_max, y2 = x_max; end
    
    if rand(1) <= 0.5, tmp = y1; y1 = y2; y2 = tmp; end
else
    y1 = x1;
    y2 = x2;
end
return
