
#include "mex.h"


void nd_rank_one_MEX(int Np, int m, double * fobj, int * index){

	for (int i = 0; i < Np; i++)
	{
        
	    //each thread reads a solution
	    double * f_pre=&fobj[m*i];
	    // mark the solution non-dominated
		int dom = 1;
        
		for (int j = 0; j < Np; j++)
		{
            if(i==j) continue;
            else
			{
				int dom_less = 0;
                int dom_more = 0;
				// read the solution next
				double * f=&fobj[m*j];
				for (int k = 0; k < m; k++)
				{
					if (f_pre[k] <= f[k]) dom_less++;
                    if (f_pre[k] >= f[k]) dom_more++;
				}
                
				if (dom_more == m && dom_less < m){
					dom = 0;
                    break;
                    
                }
			}

		}

		if (dom == 1)
        {
           index[i] = i+1;
        }
		else index[i] =-1;

	}

}

/* Matlab Mex interface*/

void mexFunction(int nlhs, mxArray *plhs[], int nrhs,
                 const mxArray *prhs[])
{

    if(nrhs != 1)
	{
		mexErrMsgTxt("one input required.");
	} else if(nlhs != 1)
	{
		mexErrMsgTxt("One output argument");
	}
    /*input data*/
    double * f;

    /*output data*/
    int * outIndex;

    // matlab reads the data in column major order
    // N represent the number of rows in original data
    int N = mxGetN(prhs[0]);
    int m = mxGetM(prhs[0]);
    // read the data pointer to the specific arrays: Column major order for a matirx
    f=mxGetPr(prhs[0]);

    // set the output matrix
    plhs[0]=mxCreateNumericMatrix(N, 1, mxINT32_CLASS, mxREAL);
    // cast the output matrix
    outIndex=(int*) mxGetData(plhs[0]);
    // call the function
    nd_rank_one_MEX(N, m, f, outIndex);

}




