function Multirun_gDBEA(def)
%This is the main file that will execute all the runs based on the
%'parameters_setting.m' file.

path=pwd;
cd(path);
addpath(strcat(pwd,strcat(filesep,'Methods')));
addpath(strcat(pwd,strcat(filesep,'Problems')));
path = pwd;
% if no argument then use the default settings
if nargin==0
    parameters_setting;
end
path11=strcat(path,filesep);
dir=strcat(path11,'Results');
mkdir(dir);
count=1;
pb = def.config;
for i= 1:length(pb)
    dir1=strcat(dir,filesep,pb{i});
    mkdir(dir1);
    cd(dir1);
    for j=1:def.multirun(i)
    dir2=strcat(dir1,filesep,'run-',num2str(j));
    mkdir(dir2);
    cd(dir2);
    % Update the definition file
    def.mutation_prob = def.mutation_pr_prob(i);
    def.crossover_prob = def.crossover_pr_prob(i);
    def.mutation_poly_eta = def.mutation_poly_prob(i);
    def.crossover_sbx_eta = def.crossover_sbx_prob(i);
    def.nf = def.nf_prob(i);
    def.seed=def.seed_prob(i)+j;
    def.popsize=def.popSize(i);
    def.gen=def.gen_prob(i);
    def.problem_name=pb{i};
    def.p1=def.s1(i);
    def.p2=def.s2(i);
    save('Params.mat', 'def');
    path1{count} = dir2; 
    count = count+1;
    cd ..;
    end
    cd ..;cd ..;
end
cd(path);
parfor i=1:length(path1)            %Use 'for' instead of 'parfor' for serial execution instead of parallel.
    cd(path1{i});
    disp(strcat('Running -> ',path1{i}));
    param=load('Params.mat');
    tic; 
    gDBEA(param.def); 
    toc;
    cd(dir);
end
cd(path);
return

