function [f,g,x] = dtlz1(objnum,x)

if nargin == 1
	prob.nf = objnum;   %number of objectives
	prob.ng = 0;        %number of constraints
    prob.k=5;           % for dtlz series
	prob.nx = prob.nf+prob.k-1;
	for i = 1:prob.nx
		prob.range(i,:) = [0,1]; %range of variables
	end
	f = prob;
else
	[f,g] = dtlz1_true(x,objnum);   %true call to the function
end
return


function [f,g] = dtlz1_true(x,objnum)

%Note: written in matrix form, so x can go in as a matrix (with n rows),
%and correspondingly f and g will also have n rows.

M = objnum;
k = 5;      %for dtlz series
temp = sum((x(:,M:M+k-1)-0.5).^2-cos(20*pi*(x(:,M:M+k-1)-0.5)),2);
G = 100*(k+temp);
 
%objective functions
f(:,1) = 0.5*prod(x(:,1:objnum-1),2).*(1+G);
for i = 2:objnum-1
f(:,i) = 0.5*prod(x(:,1:objnum-i),2).*(1-x(:,objnum-i+1)).*(1+G);
end
f(:,objnum) = 0.5*(1-x(:,1)).*(1+G);

% constraints
% Note: the expression for constraint is taken as feasible for negative
% value. For e.g. if the constraint is 5-x(1)*x(2)>=0, then it should be
% written as g(1) = x(1)*x(2)-5; Similarly, g(2), g(3) etc. for multiple
% constraints. 
g = [];     %empty for unconstrained problem
 
return